const TaskBase=require("../../task.base");
const settings=require("../../../../config/settings");
var excel = require('exceljs');
const system = require("../../../system");
const fs = require('fs');
class ParseRptTask extends TaskBase{
  constructor(){
    super(TaskBase.getServiceName(ParseRptTask));
    this.cacheData=[];
    this.ossC=system.getObject("util.ossClient");
  }
  async subBeforeTask(params){
    console.log("前置操作......",this.serviceName);
    //this.isThrough=true;
    //console.log(this.cacheManager);
    this.isDaemon=true;
 }
  async subTaskHandle(channel, message){
    var x=await this.redisClient.rpop(message);
    if(x){
      this.cacheData.push(x);
    }
    setImmediate(async ()=>{
      await this.parseXls();
    });
  }
  //读取模板文件
async  readxls(path) {
  var promise = new Promise((resv, rej) => {
      var workbook = new excel.Workbook();
      workbook.properties.date1904 = true;
      workbook.xlsx.readFile(path)
          .then(function () {
              return resv(workbook);
          }).catch(function (e) {
              return rej(e);
          });
  });
  return promise;
}
  async parseXls(){
    var pv=this.cacheData.pop();
    if(pv){
      var tohandleurls=pv.split("~");
      var rptid=tohandleurls[0];
      var bid=tohandleurls[1];
      var rptDate=tohandleurls[2];
      var rptCode=tohandleurls[3];
      var urldownload=tohandleurls[4];
      //下载文件
      var keyindex=urldownload.lastIndexOf("/");
      var keystr=urldownload.substring(keyindex+1);
      var result= await this.ossC.downfile(keystr);
      var localpath="/tmp/"+keystr;
      var wb= await this.readxls(localpath);

      var ind=rptCode.lastIndexOf("_");
      var parsefunc=rptCode;
      if(ind>=0){
        var st2=rptCode.substring(ind+1);
        if(st2=="N"){//是非必传的文件
           parsefunc=rptCode.substring(0,ind);
        }
      }
      var parserByCode=require("./rptHandler/"+parsefunc);
      var rows=await parserByCode(wb);
      this.apiCallWithAk(settings.fkweb(),{
        rptid:rptid,
        batchid:bid,
        rptdate:rptDate,
        rptcode:rptCode,
        hisdata:rows
      }).then(()=>{
        fs.unlink(localpath,(err)=>{
          (err) => {
            if (err) throw err;
            console.log('文件已删除');
          }
        });
      });
      this.parseXls();
    }
  }
  async subDoTask(params){
    console.log(params);
    console.log("TestTask1.....");
  }
}
module.exports=ParseRptTask;